package syscon.arbutus.product.services.legal.contract.dto.ordersentence;

import java.io.Serializable;
import java.util.Date;

/**
 * AggregateSentenceType  Sentence Level's sentences. Generated by Sentence Calculation Engine.
 * <p>Not able to be updated or deleted, therefore, there is no 'REQUIRED/OPTIONAL' defined in this type.
 *
 * @author yshang
 * @since November 18, 2013
 */
public class AggregateSentenceType implements Serializable {

    private static final long serialVersionUID = 6036404287801867777L;

    /**
     * Identification of AggregateSentenceType
     */
    private Long aggregateId;

    /**
     * Supervision Id
     */
    private Long supervisionId;

    /**
     * Supervision Sentence Id of SupervisionSentenceType
     */
    private Long supervisionSentenceId;

    /**
     * SentenceType Instance of SentenceType
     */
    private SentenceType sentence;

    /**
     * isControllingSentence True: is controlling sentence; Null or False: is not.
     */
    private Boolean isControllingSentence;

    /**
     * Sentence Start Date
     */
    private Date startDate;

    /**
     * Sentence End Date
     */
    private Date endDate;

    /**
     * Probable release/discharge date
     */
    private Date prdDate;

    /**
     * Days sentenced
     */
    private Long sentenceDays;

    /**
     * Good Time -- Sentence adjustment type: GT(Good Time)
     */
    private Long goodTime;

    /**
     * Years of duration of the sentence
     */
    private Long years;

    /**
     * Months of duration of the sentence
     */
    private Long months;

    /**
     * Weeks of duration of the sentence
     */
    private Long weeks;

    /**
     * Days of duration of the sentence
     */
    private Long days;

    /**
     * Expire date of the sentence
     */
    private Date expiryDate;

    /**
     * Staff Id
     */
    private Long staffId;

    /**
     * Comment of the sentence by staffId
     */
    private String comment;

    /**
     * Date of calculation
     */
    private Date calculatingDate;

    /**
     * Constructor
     */
    public AggregateSentenceType() {
        super();
    }

    /**
     * getAggregateId
     * <p>Identification of AggregateSentenceType
     *
     * @return the aggregateId
     */
    public Long getAggregateId() {
        return aggregateId;
    }

    /**
     * setAggregateId
     * <p>Identification of AggregateSentenceType
     *
     * @param aggregateId the aggregateId to set
     */
    public void setAggregateId(Long aggregateId) {
        this.aggregateId = aggregateId;
    }

    /**
     * getSupervisionId
     * <p>Supervision Id
     *
     * @return the supervisionId
     */
    public Long getSupervisionId() {
        return supervisionId;
    }

    /**
     * setSupervisionId
     * <p>Supervision Id
     *
     * @param supervisionId the supervisionId to set
     */
    public void setSupervisionId(Long supervisionId) {
        this.supervisionId = supervisionId;
    }

    /**
     * getSupervisionSentenceId
     * <p>Id of Supervision Sentence Type
     *
     * @return the supervisionSentenceId
     */
    public Long getSupervisionSentenceId() {
        return supervisionSentenceId;
    }

    /**
     * setSupervisionSentenceId
     * <p>Id of Supervision Sentence Type
     *
     * @param supervisionSentenceId the supervisionSentenceId to set
     */
    public void setSupervisionSentenceId(Long supervisionSentenceId) {
        this.supervisionSentenceId = supervisionSentenceId;
    }

    /**
     * getSentence
     * <p>The instance of SentenceType
     *
     * @return the sentence
     */
    public SentenceType getSentence() {
        return sentence;
    }

    /**
     * setSentence
     * <p>The instance of SentenceType
     *
     * @param sentence the sentence to set
     */
    public void setSentence(SentenceType sentence) {
        this.sentence = sentence;
    }

    /**
     * getIsControllingSentence
     * <p>isControllingSentence True: is controlling sentence; Null or False: is not.
     *
     * @return the isControllingSentence
     */
    public Boolean getIsControllingSentence() {
        return isControllingSentence;
    }

    /**
     * setIsControllingSentence
     * <p>isControllingSentence True: is controlling sentence; False: is not.
     *
     * @param isControllingSentence the isControllingSentence to set
     */
    public void setIsControllingSentence(Boolean isControllingSentence) {
        this.isControllingSentence = isControllingSentence;
    }

    /**
     * getStartDate
     * <p>Sentence Start Date
     *
     * @return the startDate
     */
    public Date getStartDate() {
        return startDate;
    }

    /**
     * setStartDate
     * <p>Sentence Start Date
     *
     * @param startDate the startDate to set
     */
    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    /**
     * getEndDate
     * <p>Sentence End Date
     *
     * @return the endDate
     */
    public Date getEndDate() {
        return endDate;
    }

    /**
     * setEndDate
     * <p>Sentence End Date
     *
     * @param endDate the endDate to set
     */
    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

    /**
     * getPrdDate
     * <p>Probable Release/Discharge Date
     *
     * @return the prdDate
     */
    public Date getPrdDate() {
        return prdDate;
    }

    /**
     * setPrdDate
     * <p>Probable Release/Discharge Date
     *
     * @param prdDate the prdDate to set
     */
    public void setPrdDate(Date prdDate) {
        this.prdDate = prdDate;
    }

    /**
     * getSentenceDays
     * <p>Days sentenced
     *
     * @return the sentenceDays
     */
    public Long getSentenceDays() {
        return sentenceDays;
    }

    /**
     * setSentenceDays
     * <p>Days sentenced
     *
     * @param sentenceDays the sentenceDays to set
     */
    public void setSentenceDays(Long sentenceDays) {
        this.sentenceDays = sentenceDays;
    }

    /**
     * getGoodTime
     * <p>Good Time -- Sentence adjustment type: GT(Good Time)
     *
     * @return the goodTime
     */
    public Long getGoodTime() {
        return goodTime;
    }

    /**
     * setGoodTime
     * <p>Good Time -- Sentence adjustment type: GT(Good Time)
     *
     * @param goodTime the goodTime to set
     */
    public void setGoodTime(Long goodTime) {
        this.goodTime = goodTime;
    }

    /**
     * getYears
     * <p>Years of duration of the sentence
     *
     * @return the years
     */
    public Long getYears() {
        return years;
    }

    /**
     * getYears
     * <p>Years of duration of the sentence
     *
     * @param years the years to set
     */
    public void setYears(Long years) {
        this.years = years;
    }

    /**
     * getMonths
     * <p>Months of duration of the sentence
     *
     * @return the months
     */
    public Long getMonths() {
        return months;
    }

    /**
     * setMonths
     * <p>Months of duration of the sentence
     *
     * @param months the months to set
     */
    public void setMonths(Long months) {
        this.months = months;
    }

    /**
     * getWeeks
     * <p>Weeks of duration of the sentence
     *
     * @return the weeks
     */
    public Long getWeeks() {
        return weeks;
    }

    /**
     * setWeeks
     * <p>Weeks of duration of the sentence
     *
     * @param weeks the weeks to set
     */
    public void setWeeks(Long weeks) {
        this.weeks = weeks;
    }

    /**
     * getDays
     * <p>Days of duration of the sentence
     *
     * @return the days
     */
    public Long getDays() {
        return days;
    }

    /**
     * setDays
     * <p>Days of duration of the sentence
     *
     * @param days the days to set
     */
    public void setDays(Long days) {
        this.days = days;
    }

    /**
     * getExpiryDate
     * <p>Expire Date of the sentence
     *
     * @return the expiryDate
     */
    public Date getExpiryDate() {
        return expiryDate;
    }

    /**
     * setExpiryDate
     * <p>Expire Date of the sentence
     *
     * @param expiryDate the expiryDate to set
     */
    public void setExpiryDate(Date expiryDate) {
        this.expiryDate = expiryDate;
    }

    /**
     * getStaffId
     * <p>Staff Id
     *
     * @return the staffId
     */
    public Long getStaffId() {
        return staffId;
    }

    /**
     * setStaffId
     * <p>Staff Id
     *
     * @param staffId the staffId to set
     */
    public void setStaffId(Long staffId) {
        this.staffId = staffId;
    }

    /**
     * getComment
     * <p>Comment by staff
     *
     * @return the comment
     */
    public String getComment() {
        return comment;
    }

    /**
     * setComment
     * <p>Comment by staff
     *
     * @param comment the comment to set
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    /**
     * getCalculatingDate
     * <p>Date of calculation
     *
     * @return the calculatingDate
     */
    public Date getCalculatingDate() {
        return calculatingDate;
    }

    /**
     * setCalculatingDate
     * <p>Date of calculation
     *
     * @param calculatingDate the calculatingDate to set
     */
    public void setCalculatingDate(Date calculatingDate) {
        this.calculatingDate = calculatingDate;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((aggregateId == null) ? 0 : aggregateId.hashCode());
        result = prime * result + ((isControllingSentence == null) ? 0 : isControllingSentence.hashCode());
        result = prime * result + ((sentence == null) ? 0 : sentence.hashCode());
        result = prime * result + ((supervisionId == null) ? 0 : supervisionId.hashCode());
        result = prime * result + ((supervisionSentenceId == null) ? 0 : supervisionSentenceId.hashCode());
        return result;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
			return true;
		}
        if (obj == null) {
			return false;
		}
        if (getClass() != obj.getClass()) {
			return false;
		}
        AggregateSentenceType other = (AggregateSentenceType) obj;
        if (aggregateId == null) {
            if (other.aggregateId != null) {
				return false;
			}
        } else if (!aggregateId.equals(other.aggregateId)) {
			return false;
		}
        if (isControllingSentence == null) {
            if (other.isControllingSentence != null) {
				return false;
			}
        } else if (!isControllingSentence.equals(other.isControllingSentence)) {
			return false;
		}
        if (sentence == null) {
            if (other.sentence != null) {
				return false;
			}
        } else if (!sentence.equals(other.sentence)) {
			return false;
		}
        if (supervisionId == null) {
            if (other.supervisionId != null) {
				return false;
			}
        } else if (!supervisionId.equals(other.supervisionId)) {
			return false;
		}
        if (supervisionSentenceId == null) {
            if (other.supervisionSentenceId != null) {
				return false;
			}
        } else if (!supervisionSentenceId.equals(other.supervisionSentenceId)) {
			return false;
		}
        return true;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return "AggregateSentenceType [aggregateId=" + aggregateId + ", supervisionId=" + supervisionId + ", supervisionSentenceId=" + supervisionSentenceId
                + ", sentence=" + sentence + ", isControllingSentence=" + isControllingSentence + ", startDate=" + startDate + ", endDate=" + endDate + ", prdDate="
                + prdDate + ", sentenceDays=" + sentenceDays + ", goodTime=" + goodTime + ", years=" + years + ", months=" + months + ", weeks=" + weeks + ", days="
                + days + ", expiryDate=" + expiryDate + ", staffId=" + staffId + ", comment=" + comment + ", calculatingDate=" + calculatingDate + "]";
    }

}
